#!/usr/bin/perl
#
#*****************************************************************************
# WARNING - this is a TEST version. It is likely to explode in your face,
# cause a meltdown in a nearby nuclear powerstation or do other nasty things
# like that...
#*****************************************************************************
#
########################################################################
# Basic User Administration Script for the Albert Fong Device
# 21 Aug 2000 - TheGame (jointhegame@crosswinds.net)
#
# TODO : add some more advanced features like rank modification, banning etc.
#

    ########################
    # Specific User Admin variables
    #

	$user_url = "http://www.yoursite.com/cgi-bin/fd_user.cgi"; # URL where this fd_user.cgi script is
	$user_db = "user_db";	# this will go in the $datadir as well


    ########################
    # File Locations
    #

	$basedir = "/full_path/to/wwwboard";  # real path where your board dir is (your FTP client usually shows the real path)
	$baseurl = "http://www.yoursite.com/wwwboard";  # URL of your board dir
	@referers = ('www.yoursite.com', 'yoursite.com'); # base domain name where your site is

	$datadir = "/full_path/to/data_dir";  # real path where the config files are located (your FTP client usually shows the real path)

	$logfile = "my_log";		# Change these for some privacy !


    # Done! - thats all you *need* to edit. now just chmod everything, (incl. the 'messages'
    # directory) to 777, and the .cgi scripts to 755. then, tweak the stuff below to how you want.
    ###########

	$mesgfile = "index.html";	# It might be better security if you change them,


    ############################
    # Look / Feel Variables
    #
    # Note : if you have some SSI headers and/or footers (e.g. for banners),
    #        just add them here
    #

	$title = "User Administration";	# Title of the board

	# This html will go at the TOP of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$background = <<'EOBackground';
<!-- start copy & paste background from your index.html -->

 <BODY BGCOLOR="#336699" TEXT="#FFFFFF" LINK="#FFFFFF" VLINK="#C0C0C0" ALINK="#C0C0C0">
 <FONT FACE="arial">

<!-- end copy & paste background from your index.html -->
EOBackground

# don't delete or change the 2 lines that say "EOBackground" - that means no spaces, no tabs, etc. !

	# This html will go at the BOTTOM of every page (all error pages, message posts, etc.)
	# It's regular HTML code that you can cut and paste from an existing page.

	$page_bottom = <<'EOPageBottom';
<!-- start copy & paste page_bottom from your index.html -->

 <BR>
 <SMALL>
 This board is powered by the <A HREF="http://www.cyberarmy.com/search/Programming/Releases/CyberArmy/Mr_Fong_Device">Mr. Fong Device</A> from Cyberarmy.com
 </SMALL>
 <BR>

<!-- end copy & paste page_bottom from your index.html -->
</BODY>
</HTML>
EOPageBottom
# don't delete or change the 2 lines that say "EOPageBottom" - that means no spaces, no tabs, etc. !

	$contact = '';			# put your e-mail address here if you want it to show as a mailto: link in error messages
					# example : $contact = 'webmaster@cyberarmy.com';


    ###################################
    # Security Variables (1=ON, 0=OFF)
    # 

	$log_errors = 1;		# log any script errors - you should leave this ON (and check your logfile from time to time !)
	$log_warnings = 0;		# log any warnings that people receive - this may be useful when you start a new board

	$max_name = 25;			# If cut_fields is on, the length to cut
	$max_url = 120;			#
	$max_url_title = 80;		# Leave reasonable limits on all sections to stop
	$max_email = 80;		# people posting 10 MB messages, etc.
	$max_img = 120;			# IF YOU CHANGE THIS, DON'T FORGET TO CHANGE THE FORM IN INDEX.HTML TOO !

#
# Nothing (necessary) to edit Past This Point
# A few things for advanced users only.
##############################################

#######################################################################
#                                                                     #
# Warning to Perl programmers and would-be code copiers :             #
#                                                                     #
# The following script does NOT represent a good way of programming   #
# in Perl - do not use it as an example on how to do Perl/CGI stuff ! #
#                                                                     #
#######################################################################

    ###################################
    # System-dependent variables
    #

	$addr_type = 2; # this should be AF_INET from the Socket module
	$lock_ex = 2; # this should be LOCK_EX from the Fcntl module

	# Define what to show in case of errors
	if ($contact) {
		$webmaster = "<A HREF=\"mailto:$contact\">webmaster</A>";
	}
	else {
		$webmaster = "webmaster";
	}


###################################
# Main Script
#

use CGI qw(:standard);

# Remove output buffering
$|=1;

# check referrer
#check_ref();

# Check if the user is already authenticated
my $key = cookie('key');
if (length($key) == 24) {

	# check if we have a name that goes with that key
	get_userinfo($key);
	if (!defined($userinfo{'name'}) || length($userinfo{'name'}) == 0) {
		$msg = 'You seem to have an invalid cookie. Please identify yourself again :';
		$cookie = cookie(-name=>'key',
				-value=>'',
				-path=>'/',
				-expires=>'+1y');
		show_login($msg,$cookie);
	}

	# check if the user wants to clear is cookie
	if (param('clear')) {
		$msg = 'Your cookie has been cleared.';
		$cookie = cookie(-name=>'key',
				-value=>'',
				-path=>'/',
				-expires=>'+1y');
		show_login($msg,$cookie);
	}
	# check if the user wants to update some info
	elsif (param('update')) {
		# get the different field values
		my $email = clean_var(param('email'),$max_email);
		my $img = clean_var(param('img'),$max_img);
		my $url_title = clean_var(param('url_title'),$max_url_title);
		my $url = clean_var(param('url'),$max_url);

		# catch some common mistakes
		$img =~ s#^http:?//##;
		$url =~ s#^http:?//##;

		# update the user information
		update_user($key,$email,$img,$url_title,$url);

		$msg = 'You are now defined as follows in the User Database :';
	}
	else {
		$msg = 'You are defined as follows in the User Database :';
	}

	# return the user information and the cookie
	$cookie = cookie(-name=>'key',
			-value=>$userinfo{'key'},
			-path=>'/',
			-expires=>'+1y');
	show_info($msg,$cookie);
}
# if not, see if the user already exists
elsif (param('login')) {
	my $name = clean_var(param('name'),$max_name);
	my $passwd = clean_var(param('passwd'),$max_name);
	find_user($name,$passwd);

	# check if we find that name in the database
	# note : invalid passwords are intercepted in the find_user() routine and logged
	if (!defined($userinfo{'name'}) || length($userinfo{'name'}) == 0) {
		# the user doesn't seem to exist yet, so we go to registration
		show_register($name,$passwd);
	}

	# return the user information and the cookie
	$msg = 'You are defined as follows in the User Database :';
	$cookie = cookie(-name=>'key',
			-value=>$userinfo{'key'},
			-path=>'/',
			-expires=>'+1y');
	show_info($msg,$cookie);
}
# if not, see if the user wants to register now
elsif (param('register')) {
	# get the different field values
	my $name = clean_var(param('name'),$max_name);
	my $passwd = clean_var(param('passwd'),$max_name);
	my $confirm = clean_var(param('confirm'),$max_name);
	my $email = clean_var(param('email'),$max_email);
	my $img = clean_var(param('img'),$max_img);
	my $url_title = clean_var(param('url_title'),$max_url_title);
	my $url = clean_var(param('url'),$max_url);

	# catch some common mistakes
	$img =~ s#^http:?//##;
	$url =~ s#^http:?//##;

	# check if the password matches the confirmation
	if ($passwd ne $confirm) {
		show_register($name,"");
	}

	# create the user
	# note : create_user checks if someone else already registered under this name
	create_user($name,$passwd,$email,$img,$url_title,$url);

	# return the user information and the cookie
	$msg = 'You are now defined as follows in the User Database :';
	$cookie = cookie(-name=>'key',
			-value=>$userinfo{'key'},
			-path=>'/',
			-expires=>'+1y');
	show_info($msg,$cookie);
}
# otherwise, show the default login/registration page
else {
	show_login('Please register or identify yourself :','');
}

# That's all, folks !
exit;

#
# End of Main Script
###################################


###################################
# Show login/registration page
#

sub show_login {
	my($msg,$cookie) = @_;

	if ($cookie) {
		print header(-cookie=>$cookie);
	}
	else {
		print header;
	}

	print <<EOT;
<HTML>
<HEAD>
	<TITLE>$title</TITLE>
</HEAD>
$background
	<H2>$title</H2>
	Welcome to the User Administration script for the Albert Fong Device.
	<P>
	$msg
	<P>
	<BLOCKQUOTE>
	<FORM METHOD="POST">
	<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0>
	<TR><TD>Name :</TD><TD><INPUT TYPE="text" NAME="name" MAXLENGTH=$max_name></TD></TR>
	<TR><TD>Password :</TD><TD><INPUT TYPE="password" NAME="passwd" MAXLENGTH=$max_name></TD></TR>
	</TABLE>
	<P>
	<INPUT TYPE="submit" NAME="login" VALUE="Identify Me">
	</FORM>
	</BLOCKQUOTE>
	<P>
	<a href="$baseurl/$mesgfile">Back to the board</a>
	<P>
$page_bottom
EOT
	exit;
}

###################################
# Show registration page
#

sub show_register {
	my($name,$passwd) = @_;

	$name = escapeHTML($name);
	$passwd = escapeHTML($passwd);

	print header;

	print <<EOT;
<HTML>
<HEAD>
	<TITLE>$title</TITLE>
</HEAD>
$background
	<H2>$title</H2>
	Please confirm your name and password. You can also specify your default e-mail, image and website link for the board :
	<P>
	<BLOCKQUOTE>
	<FORM METHOD="POST">
	<TABLE BORDER=1 CELLPADDING=5 CELLSPACING=0>
		<TR><TD ALIGN="right">Name :</TD><TD><INPUT TYPE="text" NAME="name" MAXLENGTH=$max_name VALUE="$name"></TD></TR>
		<TR><TD ALIGN="right">Password :</TD><TD><INPUT TYPE="password" NAME="passwd" MAXLENGTH=$max_name VALUE="$passwd"></TD></TR>
		<TR><TD ALIGN="right">Confirm :</TD><TD><INPUT TYPE="password" NAME="confirm" MAXLENGTH=$max_name></TD></TR>
		<TR><TD ALIGN="right">E-mail</TD><TD><INPUT TYPE="text" SIZE=45 NAME="email" MAXLENGTH=$max_email> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Image URL</TD><TD>http:// <INPUT TYPE="text" SIZE=45 NAME="img" MAXLENGTH=$max_img> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Website Title</TD><TD><INPUT TYPE="text" SIZE=45 NAME="url_title" MAXLENGTH=$max_url_title> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Website URL</TD><TD>http:// <INPUT TYPE="text" SIZE=45 NAME="url" MAXLENGTH=$max_url> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">&nbsp;</TD><TD><INPUT TYPE="submit" NAME="register" VALUE="Register Now"></TD></TR>
	</TABLE>
	</FORM>
	</BLOCKQUOTE>
	<P>
	<a href="$baseurl/$mesgfile">Back to the board</a>
	<P>
$page_bottom
EOT
	exit;
}

###################################
# Show user information
#

sub show_info {
	my($msg,$cookie) = @_;

	if ($cookie) {
		print header(-cookie=>$cookie);
	}
	else {
		print header;
	}

	my $name = escapeHTML($userinfo{'name'});
	my $email = escapeHTML($userinfo{'email'});
	my $groups = escapeHTML($userinfo{'groups'});
	my $img = escapeHTML($userinfo{'img'});
	my $url_title = escapeHTML($userinfo{'url_title'});
	my $url = escapeHTML($userinfo{'url'});

	print <<EOT;
<HTML>
<HEAD>
	<TITLE>$title</TITLE>
</HEAD>
$background
	<H2>$title</H2>
	$msg
	<P>
	<BLOCKQUOTE>
	<FORM METHOD="POST">
	<TABLE BORDER=1 CELLPADDING=5 CELLSPACING=0>
		<TR><TD ALIGN="right">Name</TD><TD>$name &nbsp;&nbsp; <INPUT TYPE="submit" NAME="clear" VALUE="Clear Cookie"></TD></TR>
		<TR><TD ALIGN="right">Rank</TD><TD>$groups &nbsp;</TD></TR>
		<TR><TD ALIGN="right">E-mail</TD><TD><INPUT TYPE="text" SIZE=45 NAME="email" MAXLENGTH=$max_email VALUE="$email"> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Image URL</TD><TD>http:// <INPUT TYPE="text" SIZE=45 NAME="img" MAXLENGTH=$max_img VALUE="$img"> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Website Title</TD><TD><INPUT TYPE="text" SIZE=45 NAME="url_title" MAXLENGTH=$max_url_title VALUE="$url_title"> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">Website URL</TD><TD>http:// <INPUT TYPE="text" SIZE=45 NAME="url" MAXLENGTH=$max_url VALUE="$url"> &nbsp;</TD></TR>
		<TR><TD ALIGN="right">&nbsp;</TD><TD><INPUT TYPE="submit" NAME="update" VALUE="Update Information"></TD></TR>
	</TABLE>
	</FORM>
	</BLOCKQUOTE>
	<P>
	<a href="$baseurl/$mesgfile">Back to the board</a>
	<P>
$page_bottom
EOT
	exit;
}

###################################
# a. Show script error message and die
#

sub show_die {
	my($msg) = @_;

	print header;

	print <<EOT;
<HTML>
<HEAD>
	<TITLE>$title - SCRIPT ERROR</TITLE>
</HEAD>
$background
<H2>$title - SCRIPT ERROR</H2>
The following error was encountered while processing your request :
 <P>
 <TABLE BORDER="1" CELLPADDING="5"><TR><TD>
 <B>$msg</B>
 </TD></TR></TABLE>
 <BR>
<B>Go back and try again.</B>
<P>
Note : This error and your details have been logged. If this error persists, contact the $webmaster.
<P>
$page_bottom
EOT

	# Log the reason for dying
	if ($log_errors == 1) {
		log_msg("Script Error : $msg");
	}

	# We stop here
	exit;
}


###################################
# b. Log script error messages
#

sub log_msg {
	my($msg) = @_;

	# we can't use show_die() here, of course
	if (open(LOG,">>$datadir/$logfile")) {
		$date = scalar gmtime();
		print LOG "$date - $ENV{'REMOTE_ADDR'} - $msg";
		close(LOG);
	}
}

###################################
# Check referrer (and user agent)
#

sub check_ref {
	# check for authorization
	$requrl = $ENV{'HTTP_REFERER'};
	$flag = 0;

	if ((!$ENV{'HTTP_REFERER'}) || (!$ENV{'HTTP_USER_AGENT'})) {
		$flag=0;
	}
	else {
		foreach $each (@referers){
			if ($requrl =~ /$each/i){
				$flag=1;
				last;
			}
		}
	}
	if ($flag == 1) {
		return;
	}

	print header;

	print <<EOT;
 <HTML>
 <HEAD>
 	<TITLE>$title - Security Lockout</TITLE>
 </HEAD>
 $background
 <center><H2>$title - Security Lockout</H2></center>
 <br><p>
 This script can only be called from <B>http://$referers[0]/</B>, to help prevent people exploiting it.
 For some reason, the script has determined that it was not called from there.
 Occassionaly, it is mistaken. If you are not trying to hack us, you should retype
 the URL in your browser, reload the page, and try again.
 <BR>
 If that still doesn't work, contact the webmaster.
 <P>
 This error and your details have been logged.
 <p>
 <center>[ <a href="$user_url">Return to the $title</a> ]</center>
 $page_bottom
EOT

	if ($log_warnings == 1) {
		log_msg("WARNING : User Security Lockout - wrong referrer '$ENV{'HTTP_REFERER'}' or missing user agent...\n");
	}

	# We stop here
	exit;
}

############################################################################
#
# Some generic routines for the database authentication
#

## Get the user information from the User DB (use $userinfo{'name'} in script)

sub get_userinfo {
	my($userkey) = @_;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$user_db") || show_die("Can't open user database - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock user database - $!\n");
	chomp(@lines = <FILE>);
	close(FILE);

	foreach $line (@lines) {
		my ($name,$cryptpass,$groups,$key,$email,$img,$url_title,$url,$bantime,$etc) = split(/\:/, $line);
		if ($userkey eq $key) {
			$userinfo{'name'} = $name;
			$userinfo{'cryptpass'} = $cryptpass;
			$userinfo{'groups'} = $groups;
			$userinfo{'key'} = $key;
			$userinfo{'email'} = $email;
			$userinfo{'img'} = $img;
			$userinfo{'url_title'} = $url_title;
			$userinfo{'url'} = $url;
			$userinfo{'bantime'} = $bantime;
			$userinfo{'etc'} = $etc;
			last;
		}
	}
}

## Find the user in the User DB (use $userinfo{'name'} in script)

sub find_user {
	my($username,$userpass) = @_;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$user_db") || show_die("Can't open user database - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock user database - $!\n");
	chomp(@lines = <FILE>);
	close(FILE);

	foreach $line (@lines) {
		my ($name,$cryptpass,$groups,$key,$email,$img,$url_title,$url,$bantime,$etc) = split(/\:/, $line);
		if ($username eq $name) {
			if (crypt($userpass,$cryptpass) ne $cryptpass) {
				$username = escapeHTML($username);
				show_die("Invalid password for '$username'.\n");
			}
			$userinfo{'name'} = $name;
			$userinfo{'cryptpass'} = $cryptpass;
			$userinfo{'groups'} = $groups;
			$userinfo{'key'} = $key;
			$userinfo{'email'} = $email;
			$userinfo{'img'} = $img;
			$userinfo{'url_title'} = $url_title;
			$userinfo{'url'} = $url;
			$userinfo{'bantime'} = $bantime;
			$userinfo{'etc'} = $etc;
			last;
		}
	}
}

## Create a new user in the User DB

sub create_user {
	my($new_name,$new_pass,$new_email,$new_img,$new_url_title,$new_url) = @_;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$user_db") || show_die("Can't open user database - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock user database - $!\n");
	chomp(@lines = <FILE>);

	# see if we already have this name in the database (you never know...)
	$isfound = 0;
	foreach $line (@lines) {
		my ($name,$cryptpass,$groups,$key,$email,$img,$url_title,$url,$bantime,$etc) = split(/\:/, $line);
		if ($new_name eq $name) {
			$isfound = 1;
		}
	}
	if ($isfound == 1) {
		close(FILE);
		show_die("Someone else already registered under this name while you were filling in the form...\n");
	}

	# update the user database
	seek(FILE,0,0);
	truncate(FILE,0) || show_die("Can't truncate user database - $!\n");
	foreach $line (@lines) {
		print FILE "$line\n";
	}

	# initialise the new user
	$salt = join('', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64]);
	$cryptpass = crypt($new_pass, $salt);
	$groups = 'r1';
	$key = '';
	@keyset = ('a'..'z', 'A'..'Z', '0'..'9');
	for ($i = 0; $i < 24; $i++) {
		$random_num = int(rand($#keyset + 1));
		$key .= $keyset[$random_num];
	}
	$bantime = '';
	$etc = '';

	print FILE "$new_name:$cryptpass:$groups:$key:$new_email:$new_img:$new_url_title:$new_url:$bantime:$etc\n";
	close(FILE);

	# keep this for show_info()
	$userinfo{'name'} = $new_name;
	$userinfo{'cryptpass'} = $cryptpass;
	$userinfo{'groups'} = $groups;
	$userinfo{'key'} = $key;
	$userinfo{'email'} = $new_email;
	$userinfo{'img'} = $new_img;
	$userinfo{'url_title'} = $new_url_title;
	$userinfo{'url'} = $new_url;
	$userinfo{'bantime'} = $bantime;
	$userinfo{'etc'} = $etc;
}

## Update the user information in the User DB

sub update_user {
	my($userkey,$new_email,$new_img,$new_url_title,$new_url) = @_;

	# open for read/write to allow flock to work on most platforms, even those with lockf(3)
	open(FILE,"+<$datadir/$user_db") || show_die("Can't open user database - $!\n");
	flock(FILE, $lock_ex) || show_die("Can't flock user database - $!\n");
	chomp(@lines = <FILE>);
	seek(FILE,0,0);
	truncate(FILE,0) || show_die("Can't truncate user database - $!\n");

	foreach $line (@lines) {
		my ($name,$cryptpass,$groups,$key,$email,$img,$url_title,$url,$bantime,$etc) = split(/\:/, $line);
		if ($userkey eq $key) {
			print FILE "$name:$cryptpass:$groups:$key:$new_email:$new_img:$new_url_title:$new_url:$bantime:$etc\n";
			$userinfo{'name'} = $name;
			$userinfo{'cryptpass'} = $cryptpass;
			$userinfo{'groups'} = $groups;
			$userinfo{'key'} = $key;
			$userinfo{'email'} = $new_email;
			$userinfo{'img'} = $new_img;
			$userinfo{'url_title'} = $new_url_title;
			$userinfo{'url'} = $new_url;
			$userinfo{'bantime'} = $bantime;
			$userinfo{'etc'} = $etc;
		}
		else {
			print FILE "$line\n";
		}
	}
	close(FILE);
}

## Clean up variables on registration (use $var = clean_var($var,$length); in script)

sub clean_var {
	my($var,$length) = @_;

	# remove all non "ISO Latin-1" (ISO 8859-1) printable characters (including LF)
	$var =~ tr/\040-\176\240-\377//cd;
	# convert all blanks (space, tab, newline, etc.) to space
	$var =~ s/\s+/ /g;
	# convert all double spaces (or more) to single spaces
	$var =~ s/  +/ /g;

	# remove some more unwanted characters (':' in particular - it messes up the database file)
	# Note that this does NOT make the variable safe for use in system, exec, ``, open pipes etc. !
	$var =~ tr/:<>*;,'"//d;
	# if value of this field is nothing but a space, the value is null ("");
	if ($var eq ' ') {
		$var = "";
	}

	# remove leading and trailing blanks
	$var =~ s/^\s+//;
	$var =~ s/\s+$//;

	# cut off length at $length chars
	if ($length > 0 && length($var) > $length) {
		$var = substr($var,0,$length);
	}

	return $var;
}

## Make string safe for HTML output (use $var = escapeHTML($var); in script)

sub escapeHTML {
	my($string) = @_;

	$string =~ s/&/&amp;/g;
	$string =~ s/"/&quot;/g;
	$string =~ s/</&lt;/g;
	$string =~ s/>/&gt;/g;

	return $string;
}

